#!/usr/bin/env python2

import dpkt
import logging
import sys
import settings
import time
from packet_parser import on_packet

def start(file_name):
  logging.info('Reading PCAP file: ' + file_name)
  try:
    for ts, pkt in dpkt.pcap.Reader(open(file_name,'r')):
      on_packet(len(pkt), pkt, ts)
      time.sleep(0.01)
  except KeyboardInterrupt:
    logging.info('Sniffing stopped')

if __name__ == "__main__":
  settings.init()

  if len(sys.argv) == 2:
    start(sys.argv[1])
  else:
    logging.error('Usage: python file_reader.py <pcap filename>')
