import struct

def float_to_hex(f):
    return hex(struct.unpack('<I', struct.pack('<f', f))[0])
def hex_to_float(f):
    return struct.unpack('!f', f.decode('hex'))[0]

def parse_iec_array(data):
  values = []
  #print 'Parsing IEC packet...'
  while True:
    start_ind = data.find("\x87\x05\x08")
    if start_ind < 0:
      break

    start_ind += 3;
    value = hex_to_float(data[start_ind:(start_ind + 4)].encode('hex'))
    values.append(value)
    data = data[start_ind:]

  return values