import logging
import pcap
import string
import time
import socket
import struct
from struct import *

from filter import on_tcp_ip_packet_received

def decode_tcp_ip_packet(s):
  d={}
  d['version']=(ord(s[0]) & 0xf0) >> 4
  d['header_len']=ord(s[0]) & 0x0f
  d['tos']=ord(s[1])
  d['total_len']=socket.ntohs(struct.unpack('H',s[2:4])[0])
  d['id']=socket.ntohs(struct.unpack('H',s[4:6])[0])
  d['flags']=(ord(s[6]) & 0xe0) >> 5
  d['fragment_offset']=socket.ntohs(struct.unpack('H',s[6:8])[0] & 0x1f)
  d['ttl']=ord(s[8])
  d['protocol']=ord(s[9])
  d['checksum']=socket.ntohs(struct.unpack('H',s[10:12])[0])
  d['src_addr']=pcap.ntoa(struct.unpack('i',s[12:16])[0])
  d['dst_addr']=pcap.ntoa(struct.unpack('i',s[16:20])[0])
  if d['header_len']>5:
    d['options']=s[20:4*(d['header_len']-5)]
  else:
    d['options']=None

  tcp_offs = 4*d['header_len']
  tcp_header=s[tcp_offs:tcp_offs+20]
  if len(tcp_header) == 20:
    tcph = unpack('!HHLLBBHHH' , tcp_header)
    d['src_port']=tcph[0]
    d['dst_port']=tcph[1]
    d['seq_num']=tcph[2]
    d['ack_num']=tcph[3]

    d['data']=s[tcp_offs+20:]
    return d
  else:
    return None

def on_packet(pktlen, data, timestamp):
  if not data:
    return

  if data[12:14]=='\x08\x00':
    decoded=decode_tcp_ip_packet(data[14:])
    if decoded is not None:
      on_tcp_ip_packet_received(decoded['src_addr'], decoded['dst_addr'], decoded['src_port'], decoded['dst_port'], decoded['data'])
  else:
    logging.debug('Unknown packet received')
