import logging
from datetime import datetime

def init():
  global interface
  global port
  global queue_size
  global queue_step
  global detection_threshold
  global detection_reiteration

  interface = 'eth0'
  port = 102
  queue_size = 50
  queue_step = 50
  detection_threshold = 70 # %
  detection_reiteration = 1

  # configuring logger
  filename = 'logs/log-' + str(datetime.now()) + '.log'
  # initial log level INFO, change to DEBUG for all logs
  logging.basicConfig(filename = filename,  level = logging.INFO, format='%(asctime)s %(levelname)s %(message)s')
  logging.getLogger().addHandler(logging.StreamHandler())

def print_config():
  logging.info('Interface: ' + interface)
  logging.info('Port: ' + str(port))
  logging.info('Detection queue size: ' + str(queue_size))
  logging.info('Silhouette threshold: ' + str(silhouette_threshold))
  logging.info('Detection reiteration count: ' + str(detection_reiteration))